import _ from 'lodash';
import * as moment from 'moment';

// 历史图标数据整理 数据结构参照HistoryDataSearchCmd id => chart
export const dateLine = ({data}) => !_.isArray(data) ? [] : data.map(item => ({
  key: _.uniqueId(),
  name: item.name,
  type: item.type,
  data: !_.isArray(item.pairs) ? [] : item.pairs.map(dt => ([
    moment.utc(dt.timestamp).valueOf(),
    dt.value === 'null' ? null : parseFloat(dt.value)
  ])),
}));
