import _ from 'lodash';

// 耍猴文件 gtmd寅子 还是喜欢老托 哈哈

//异步返回值验证是否存在 并返回有用的部分 为啥叫这个名字 写这个函数的时候在听小说
export const monk = (param: any, key = 'items', def = []) => {
  if (param) {
    if (param[key]) {
      return param[key];
    } else {
      return def;
    }
  } else {
    return def;
  }
}

//轮询？ 为什么不用ws 后端不给支持啊 卧槽！！！
interface IntervalParams {
  environment: any;
  timer?: any;
  callback: () => void;
}

export const plObj: any = {};
export const interval = ({environment, timer, callback}: IntervalParams) => {
  callback();
  return setInterval(() => {
    callback();
  }, !environment.polling ? 300000000000000 : timer ? timer : 3000)
};
export const polling = (url: '', options: any = {
  key: '', startUrl: [], timer: 3000, callback: () => {
  }
}, environment) => {
  const poll = option => {
    if (option.startUrl.indexOf(url) !== -1) {
      try {
        clearInterval(plObj[option.key]);
      } catch (e) {
      }
      plObj[option.key] = interval({environment, timer: option.timer, callback: () => option.callback({url})});
    } else {
      try {
        clearInterval(plObj[option.key]);
      } catch (e) {
      }
    }
  }

  if (_.isArray(options)) {
    options.forEach(option => {
      poll(option)
    })
  } else {
    poll(options)
  }
}

//对比 为啥写这个 让某个equal折腾的变sb了有木有 有木有！！！
//keys中变了任意一个 就返回true
export const noCompare = '__dont compare';
export const equal = (now, next, keys: string[] | string) => {
  let bl = false;

  switch (typeof keys) {
    case 'object':
      (<string[]>keys).forEach(key => {
        if (!_.isEqual(now[key], next[key]) && next[key] !== noCompare) {
          bl = true;
        }
      })
      break;
    case 'string':
      if (!_.isEqual(now[(<string>keys)], next[(<string>keys)]) && next[(<string>keys)] !== noCompare) {
        bl = true;
      }
      break;
    default:
  }

  return bl;
}

//为啥写这个 卧槽 完全不想bb 有bb的功夫不如写个函数
export const toggle = (type, data) => {
  const actions = [];

  if (data) {
    if (data.responseCommand.toLowerCase() === 'ok') {
      actions.push({
        type,
        payload: true,
      })
    } else {
      actions.push({
        type,
        payload: false,
      })
    }

    actions.push({
      type,
      payload: noCompare,
    })
  }

  return actions;
}

// tip tip~~~
const tipKeys = [];

interface TipParams {
  state: any;
  nextState: any;
  key: string;
  success: () => void;
  error?: () => void;
  common?: () => void;
}

export const tipCallback = ({state, nextState, key, success, error, common}: TipParams) => {
  if (equal(state, nextState, key)) {
    if (nextState[key] === true && success) {
      success();
    }

    if (nextState[key] === false && error) {
      error();
    }

    if (common) {
      common();
    }
  }
}

//core中用来辨析导出
export const fileExport = payload => {
  return payload.responseCommand.toLowerCase() === 'ok' ? {
    down: _.uniqueId(),
    url: '/file/' + payload.requestCommand,
  } : {
    down: _.uniqueId(),
    url: false,
  };
}

//组件中用来下载导出用的
export const downloadFile = (url, msg) => {
  if (url) {
    const el = document.createElement('a');
    el.href = url;
    el.click();
  } else {
    msg.error('获取导出信息失败');
  }
}

//replace object
export const replaceObj = (obj, rules: { [propName: string]: string | string[] }) => {
  let str = JSON.stringify(obj);

  _.forEach(rules, (sValue, repValue) => {
    switch (typeof sValue) {
      case 'object':
        sValue.forEach(value => {
          str = str.replace(new RegExp('"' + value + '"', 'g'), '"' + repValue + '"');
        })
        break;
      case 'string':
        str = str.replace(new RegExp('"' + sValue + '"', 'g'), '"' + repValue + '"')
        break;
      default:
    }
  });

  return JSON.parse(str);
}

// 时间法则
export const pTimeRange = {
  begin: beginTime => beginTime.format('YYYY-MM-DD') + ' 00:00:00',
  end: endTime => endTime.format('YYYY-MM-DD') + ' 23:59:59',
  range: function (beginTime, endTime) {
    return {
      beginTime: this.begin(beginTime),
      endTime: this.end(endTime),
    }
  }
}

// loading loading loading loadingloadingloadingloadingloading
export class loading {
  constructor(private store$) {
  }

  load({type, service}) {
    this.store$.dispatch({
      type,
      loading: true,
    })

    return service.then(data => ({
      type,
      payload: data,
      loading: false,
    }))
  }
}
